<?php

// Id used to identify this page within functions.
	$PageID = "VIEW_BORROWED_BOOKS";

require_once "common.inc";

require_once "config.inc";
require_once "constants.inc";
require_once "db.inc";
require_once "error.inc";
require_once "mgmnt.inc";
require_once "language.inc";
require_once "layout.inc";
require_once "MARC.inc";
require_once "search.inc";


if(isset($_REQUEST['user_card_number']))
{
	if(!valid_card_number($_REQUEST['user_card_number']))
	{
		$_REQUEST['stage'] = 1;
		$error = $langText['ERROR_INVALID_CARD'];
	}

	elseif(is_last_char($_REQUEST['user_card_number'], $config['card_number_suffix']))
		$_REQUEST['user_card_number'] = chop_last($_REQUEST['user_card_number']);
}

if(isset($_REQUEST['user_card_number']) && !isset($error))
{
	if(is_numeric($_REQUEST['user_card_number']))
		$user = mysql_fetch_array(mysql_query("SELECT * FROM users WHERE user_card_number=".$_REQUEST['user_card_number']));
	else
		$user = mysql_fetch_array(mysql_query("SELECT * FROM users WHERE user_card_number='".$_REQUEST['user_card_number']."'"));
}

/*if(isset($user['user_id']) && $user['user_id'] == USER_ID) {
	header("Location: my_page.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']);
}*/

if(isset($_REQUEST['email_reminder']) && isset($_REQUEST['user_id']))
{
 	if(my_subordinate($_REQUEST['user_id']))
	{
		if(email_reminder($_REQUEST['user_id']))
			$email_status = $langText['EMAIL_REMINDER_SUCCESS'];
		else
			$error = $langText['ERROR_EMAIL_REMINDER'];
	}
	else
		error("session violation");
}

$onLoad = "if (document.view_borrowed) document.view_borrowed.user_card_number.select(); if (document.borrow_receipt) document.borrow_receipt.submit();";

layout_header(array('onload' => $onLoad));

if(isset($_REQUEST['from']))
{
	$url = $_REQUEST['from'].".php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth'];

	layout_page_title($langText[$_REQUEST['message']], $_REQUEST['status']);

	if ($_REQUEST['from'] == 'borrow' && check_priv('RECEIPT_PRINTER') && isset($user['user_lang']) && $_REQUEST['status'] == 'ok')
	{

		list ($header, $footer) = receipt_text('borrow', $user['user_lang']);
		?>

			<form name="borrow_receipt" method="get" action="print.php">
				<input type="hidden" name="id" value="<?php echo $_REQUEST['id'] ?>" />
				<input type="hidden" name="auth" value="<?php echo $_REQUEST['auth'] ?>" />
				<input type="hidden" name="type" value="receipt" />
				<input type="hidden" name="template" value="borrow" />
				<input type="hidden" name="user_id" value="<?php echo $_REQUEST['user_id'] ?>" />
				<input type="hidden" name="card_number" value="<?php echo format_card_number($_REQUEST['user_card_number']) ?>" />
				<input type="hidden" name="date_format" value="<?php echo $user['user_date_format'] ?>" />
				<input type="hidden" name="old_ids" value="<?php echo $_REQUEST['old_ids'] ?>" />
				<input type="hidden" name="language" value="<?php echo $user['user_lang'] ?>" />
				<input type="hidden" name="header" value="<?php echo $header ?>" />
				<input type="hidden" name="footer" value="<?php echo $footer ?>" />
			</form>

		<?php
	}

	print "<script language='JavaScript'>setTimeout(\"location.href='".$url."'\", ".($config['redirect_timeout']*1000).");</script>";
}

if(isset($email_status))
	layout_page_info($email_status);

if(!isset($_REQUEST['stage']) || $_REQUEST['stage'] == 1)
{
	if(isset($error))
		layout_page_title($error, 'error');
	else
		layout_page_title();

	layout_wizard_start($langText['HEADER'], $langText['DESC_1']);

	?>

	<form name='view_borrowed' action='view_borrowed_books.php' method='post'>
        <input type='hidden' name='id' value='<?php echo $_REQUEST['id']?>'>
		<input type='hidden' name='auth' value='<?php echo $_REQUEST['auth']?>'>
		<input type='hidden' name='stage' value=2>

		<?php echo $langText['USER_CARD_NUMBER']?>:&nbsp;&nbsp;
		<input type='text' name='user_card_number' size='20'>&nbsp;&nbsp;
		<input type='submit' name='view' value='<?php echo $langText['BUTTON_VIEW'] ?>&nbsp;&gt;&gt;' class='button'>

	</form>

	<?php

}
elseif($_REQUEST['stage'] == 2 && isset($_REQUEST['user_card_number']))
{
	if(isset($_REQUEST['action']) && $_REQUEST['action'] == "reborrow")
	{
		$reborrow_ids = array();
		foreach($_REQUEST as $key => $value){
			if(preg_match("/^reborrow_[0-9]*/", $key) && $value == 'on') {
				$parts = explode("_", $key);
				$reborrow_ids[$parts[1]] = 'fail';
			}
		}
		
		$results = $reborrow_ids;
		$descriptions = array();
		$results['failures'] = count($reborrow_ids);
		$results['oks'] = 0;
		foreach($reborrow_ids as $book_id => $value)
		{
			$_REQUEST['book_id'] = $book_id;
			
			if(can_view_borrowed($user['user_id']))
			{
				$res = mysql_query(	"SELECT *
									FROM borrowed, books
									WHERE borrowed.borrowed_book_id=".$_REQUEST['book_id']."
										&& borrowed_user_id=".$user['user_id']."
										&& books.book_id=borrowed.borrowed_book_id");

				$row = mysql_fetch_array($res);

				if(mysql_num_rows($res) && $row['borrowed_time'] < $config['reborrow_max'] && $row['book_reserved'] == 0)
				{
					$res = mysql_query("UPDATE borrowed SET borrowed_date=NOW(), borrowed_time=borrowed_time+1 WHERE borrowed_book_id=".$_REQUEST['book_id']." && borrowed_user_id=".$user['user_id']);

					if(mysql_affected_rows())
					{
						$results[$_REQUEST['book_id']] = 'ok';
						$results['failures']--;
						$results['oks']++;
						$descriptions[$_REQUEST['book_id']] = $langText['OK'];
					}
				}
				elseif($row['book_reserved'] != 0)
				{
					$descriptions[$_REQUEST['book_id']] = $langText['ERROR_BOOK_RESERVED'];
				}
				elseif(!mysql_num_rows($res))
				{
					$descriptions[$_REQUEST['book_id']] = $langText['ERROR_BOOK_NOT_BORROWED'];
				}
				elseif($row['borrowed_time'] >= $config['reborrow_max'])
				{
					$descriptions[$_REQUEST['book_id']] = $langText['ERROR_BOOK_NOT_REBORROWED']." - ".$langText['TOO_MANY_TIMES']." (".$config['reborrow_max'].")";
				}
				else
					$descriptions[$_REQUEST['book_id']] = $langText['ERROR_BOOK_NOT_BORROWED'];
			}
			else
				error("session violation");
		}
		
		//print_r($_REQUEST);
		//print_r($results);
		//print_r($descriptions);
		
		if($results['failures'] == 0) {
			layout_page_title($langText['REBORROW_SUCCESS'], 'ok');
		} else {
			layout_page_title($langText['ERROR_REBORROW']." ".$results['failures']." / ".($results['failures']+$results['oks'])." ".$langText['FAILED'], 'error');
			foreach ($results as $key => $value) {
				if(is_numeric($key) && $value == 'fail') {
					layout_page_info(format_book_id($key).": ".$descriptions[$key], 'error');
				}
			}
		}

		if (check_priv('RECEIPT_PRINTER') && isset($user['user_lang']) && $results['oks'] > 0)
		{
			$accepted_books = "";
			foreach ($results as $key => $value) {
				if(is_numeric($key) && $value == 'ok') {
					$accepted_books .= $key.",";
				}
			}
			
			$accepted_books = chop_last($accepted_books);

			list ($header, $footer) = receipt_text('borrow', $user['user_lang']);
			?>

				<form name="borrow_receipt" method="get" action="print.php">
					<input type="hidden" name="id" value="<?php echo $_REQUEST['id'] ?>" />
					<input type="hidden" name="auth" value="<?php echo $_REQUEST['auth'] ?>" />
					<input type="hidden" name="type" value="receipt" />
					<input type="hidden" name="template" value="borrow" />
					<input type="hidden" name="user_id" value="<?php echo $_REQUEST['user_id'] ?>" />
					<input type="hidden" name="card_number" value="<?php echo format_card_number($_REQUEST['user_card_number']) ?>" />
					<input type="hidden" name="date_format" value="<?php echo $user['user_date_format'] ?>" />
					<input type="hidden" name="old_ids" value="<?php echo $accepted_books ?>" />
					<input type="hidden" name="language" value="<?php echo $user['user_lang'] ?>" />
					<input type="hidden" name="header" value="<?php echo $header ?>" />
					<input type="hidden" name="footer" value="<?php echo $footer ?>" />
				</form>

			<?php
		}

	}
	elseif(isset($_REQUEST['action']) && $_REQUEST['action'] == 'unreserve' && isset($_REQUEST['book_id']) && is_numeric($_REQUEST['book_id']))
	{
		if(can_view_borrowed($user['user_id']))
		{
			mysql_query("DELETE FROM reservations WHERE reserve_book_id=".$_REQUEST['book_id']);
			mysql_query("UPDATE books SET book_reserved=0 WHERE book_id=".$_REQUEST['book_id']);

			if(mysql_affected_rows()) {
				layout_page_title($langText['UNRESERVE_SUCCESS'], 'ok');
			} else {
				layout_page_title($langText['ERROR_UNRESERVE'], 'error');
			}
		}
		else {
			error("session violation");
		}
	}

	$comma_separated_list = "";

	if(can_view_borrowed($user['user_id']))
	{
    	//$user = mysql_fetch_array(mysql_query("SELECT user_real_name FROM users WHERE user_id=".$_REQUEST['user_id']));

		layout_page_title(format_user_real_name($user));

		layout_wizard_start($langText['HEADER'], $langText['DESC_2']);

		$res = mysql_query("SELECT book_id, book_reserved FROM books WHERE book_id IN (SELECT borrowed_book_id FROM borrowed WHERE borrowed_user_id=".$user['user_id'].")");

		if(mysql_num_rows($res))
		{

			while($sql_row = mysql_fetch_array($res))
			{
				$comma_separated_list .= $sql_row['book_id'].",";
			}

			$comma_separated_list = chop_last($comma_separated_list);

			$headers = array("&nbsp;", $langText['BOOK_ID']);
    		foreach ($MARC_display_in_list as $value)
			{
				array_push($headers, $langText[strtoupper($MARC_config[$value])]);
			}
			array_push($headers, $langText['BOOK_STATUS']);
			
			print "	<form name='reborrow' action='view_borrowed_books.php' method='get'>
						<input type='hidden' name='id' value='".$_REQUEST['id']."'>
						<input type='hidden' name='auth' value='".$_REQUEST['auth']."'>";
			
            layout_table_header($headers);

			list($book_list, $book_ids_only, $books) = zebra_list_syntax($comma_separated_list);

			$_REQUEST['element'] = "F";
            if(count($books) > 1)
				list($YAZ_items, $hits) = search("001", $book_list, "1", count($books), "", "", "@or");
			else
				list($YAZ_items, $hits) = search("001", $book_list, "1");

			$i = 0;
			$hits_inc = 0;
			$old_rows = array();
			$id_array = array();
			$print_reminder_form = false;
			$print_email_form = false;
			$color = 1;
			if($hits)
			{
				while($i < count($books))
				{
					$row = array();
					
					if(array_key_exists($book_ids_only[$i], $old_rows))
					{
						$row = $old_rows[$book_ids_only[$i]];
					}
				    else
					{
						parseMARC($YAZ_items[$hits_inc]);
						$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
						$old_rows[$book_ids_only[$i]] = $row;
						$hits_inc++;
					}

					$content = array(format_control_number($books[$i]).$config['book_id_suffix']);
                    while(list($key, $value) = each($row))
					{
						array_push($content, $row[$key]);
					}

					$expiry = mysql_fetch_array(mysql_query("SELECT books.book_id, books.book_reserved, UNIX_TIMESTAMP(borrowed.borrowed_date)
															FROM books, borrowed
															WHERE borrowed.borrowed_book_id=books.book_id && borrowed_book_id=".$books[$i]));

					list($expiry_format, $expiry_epoch) = expiry_date($expiry['UNIX_TIMESTAMP(borrowed.borrowed_date)']);
					
					array_push($id_array, $expiry['book_id']);

					if($expiry['book_reserved'] == 0) {
						//$reborrow = "<a href='view_borrowed_books.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&user_card_number=".$_REQUEST['user_card_number']."&stage=2&action=reborrow&book_id=".$books[$i]."'>".layout_insertImg("icon_reborrow.png")."</a>";
						$selected = (isset($_REQUEST['reborrow_'.$expiry['book_id']]) && $_REQUEST['reborrow_'.$expiry['book_id']] == 'on') ? 'checked' : '';
						$reborrow = '<input type="checkbox" name="reborrow_'.$expiry["book_id"].'" '.$selected.'>';
						if(isset($results) && isset($results[$expiry['book_id']]) && $results[$expiry['book_id']] == 'fail') {
							$reborrow = "
								<table border='0' cellspacing='0' cellpadding='0'>
									<tr>
										<td nowrap>".layout_InsertImg('icon_error_indicator.png')."</td>
										<td nowrap>$reborrow</td>
									</tr>
								</table>";
						}
					}
					else {
						$reborrow = "";
					}

					if($expiry_epoch > time())
					{
						$status = $langText['BOOK_EXPIRY'].": ".$expiry_format;
						$color = 'auto';

						array_push($content, $status);
						array_unshift($content, $reborrow);
					}
					else
					{
						$status = $langText['BOOK_EXPIRED'].": ".$expiry_format;

						array_push($content, $status);

						$print_reminder_form = true;
						$print = "<a href='javascript:document.forms.print_reminder.submit();' class='no-underline'>".layout_insertImg('icon_print_reminder.png')."</a>";
							
						if(valid_email_address($user['user_email']))
						{
							$print_email_form = true;
							$email = "<a href='javascript:document.forms.email_reminder.submit();' class='no-underline'>".layout_insertImg('icon_email_reminder.png')."</a>";
						}
						else
						{
							$email = "";
						}

						$reminders = "
							<table border='0' cellspacing='0' cellpadding='0'>
								<tr>
									<td nowrap>$reborrow</td>
									<td width='5'></td>
									<td nowrap>$print</td>
									<td width='5'></td>
									<td nowrap>$email</td>
								</tr>
							</table>
						";

						$color = ($color == 4) ? 3 : 4;
						array_unshift($content, $reminders);
					}

					layout_table_row($content, $color);

					$i++;
				}
			}

			$reborrow_button = "	<input type='hidden' name='action' value='reborrow'>
									<input type='hidden' name='stage' value='2'>
									<input type='hidden' name='user_card_number' value=".$_REQUEST['user_card_number'].">
									<input type='button' name='reborrow' value='".$langText['BUTTON_REBORROW']."' class='button' onClick='document.forms.reborrow.submit();'>
								</form>";
			
			$print_borrowed = "<form name='print' action='perl/PDF.pl' method='get'>
								   	<input type='hidden' name='id' value='".$_REQUEST['id']."'>
									<input type='hidden' name='auth' value='".$_REQUEST['auth']."'>
									<input type='hidden' name='perl_id' value='".$config['perl_id']."'>
									<input type='hidden' name='perl_auth' value='".md5($config['perl_auth'])."'>
									<input type='hidden' name='from_url' value='".get_base_url()."pdf.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&page=view_borrowed&user_id=".$user['user_id']."'>
									<input type='submit' name='user_list' value='".$langText['BUTTON_PRINT']."' class='button'>
								</form>";
			
			layout_table_footer($reborrow_button.$print_borrowed);
						
			if($print_reminder_form) {
				print	"<form name='print_reminder' action='perl/PDF.pl' method='get'>
							<input type='hidden' name='id' value='".$_REQUEST['id']."'>
							<input type='hidden' name='auth' value='".$_REQUEST['auth']."'>
							<input type='hidden' name='perl_id' value='".$config['perl_id']."'>
							<input type='hidden' name='perl_auth' value='".md5($config['perl_auth'])."'>
							<input type='hidden' name='from_url' value='".get_base_url()."pdf.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&page=print_reminder&user_id=".$user['user_id']."'>
							<input type='hidden' name='landscape' value='false'>
						</form>";
			}
			
			if($print_email_form) {
				print	"<form name='email_reminder' action='view_borrowed_books.php' method='post'>
							<input type='hidden' name='id' value='".$_REQUEST['id']."'>
							<input type='hidden' name='auth' value='".$_REQUEST['auth']."'>
							<input type='hidden' name='user_card_number' value='".$_REQUEST['user_card_number']."'>
							<input type='hidden' name='user_id' value='".$user['user_id']."'>
							<input type='hidden' name='email_reminder' value=1>
							<input type='hidden' name='stage' value=2>
						</form>";
			}
		}
		else {
			layout_page_info($langText['NO_BOOKS_BORROWED'], 'error');
		}

		layout_wizard_stop();

	}
	else {
		layout_page_info($langText['ERROR_NO_PERMISSION'], 'error');
	}

	// View reserved books

	if(can_view_borrowed($user['user_id']))
	{
		$comma_separated_list = "";
		$res = mysql_query("SELECT book_id, book_reserved FROM books WHERE book_id IN (SELECT reserve_book_id FROM reservations WHERE reserve_user_id=".$user['user_id'].")");

		layout_page_info($langText['RESERVED_BOOKS']);

		layout_wizard_start($langText['HEADER'], $langText['DESC_2']);

		if(mysql_num_rows($res))
		{
			while($sql_row = mysql_fetch_array($res))
			{
				$comma_separated_list .= $sql_row['book_id'].",";
			}

			$comma_separated_list = chop_last($comma_separated_list);

			$headers = array("&nbsp;", $langText['BOOK_ID']);
			foreach ($MARC_display_in_list as $value)
			{
				array_push($headers, $langText[strtoupper($MARC_config[$value])]);
			}
			array_push($headers, $langText['BOOK_STATUS'], $langText['BOOK_RESERVED']);
			layout_table_header($headers);

			list($book_list, $book_ids_only, $books) = zebra_list_syntax($comma_separated_list);

			$_REQUEST['element'] = "F";
			if(count($books) > 1)
				list($YAZ_items, $hits) = search("001", $book_list, "1", count($books), "", "", "@or");
			else
				list($YAZ_items, $hits) = search("001", $book_list, "1");

			$i = 0;
			$hits_inc = 0;
			$old_rows = array();
			$color = 1;
			if($hits)
			{
				while($i < count($books))
				{
					$row = array();

					if(array_key_exists($book_ids_only[$i], $old_rows))
					{
						$row = $old_rows[$book_ids_only[$i]];
					}
					else
					{
						parseMARC($YAZ_items[$hits_inc]);
						$row = createMARCRow(return_with_format_syntax($MARC_display_in_list));
						$old_rows[$book_ids_only[$i]] = $row;
						$hits_inc++;
					}

					$content = array("<a href='view_borrowed_books.php?id=".$_REQUEST['id']."&auth=".$_REQUEST['auth']."&user_card_number=".$_REQUEST['user_card_number']."&stage=2&action=unreserve&book_id=".$books[$i]."'>".layout_insertImg("icon_unreserve_book.png")."</a>", format_control_number($books[$i]).$config['book_id_suffix']);
					while(list($key, $value) = each($row))
					{
						array_push($content, $row[$key]);
					}

					$expiry = mysql_fetch_array(mysql_query("SELECT books.book_reserved, books.book_borrowed, UNIX_TIMESTAMP(borrowed.borrowed_date)
															FROM books, borrowed
															WHERE borrowed.borrowed_book_id=books.book_id && borrowed_book_id=".$books[$i]));

					$reserve = mysql_fetch_array(mysql_query("SELECT UNIX_TIMESTAMP(reserve_date) AS reserve_epoch FROM reservations WHERE reserve_book_id=".$books[$i]));

					list($expiry_format, $expiry_epoch) = expiry_date($expiry['UNIX_TIMESTAMP(borrowed.borrowed_date)']);

					if($expiry['book_borrowed'])
					{
						if($expiry_epoch > time())
						{
							$status = $langText['BOOK_EXPIRY'].": ".$expiry_format;
							if($color == 1)
								$color = 2;
							else
								$color = 1;

							array_push($content, $status);
						}
						else
						{
							$status = $langText['BOOK_EXPIRED'].": ".$expiry_format;
							if($color == 3)
								$color = 4;
							else
								$color = 3;

							array_push($content, $status);
						}
					}
					else
					{
						$status = $langText['IN_SHELF'];
						array_push($content, $status);
						$color = 1;
					}
					array_push($content, date(USER_DATE_FORMAT, $reserve['reserve_epoch']));

					layout_table_row($content, $color);

					$i++;
				}
			}

			layout_table_footer();

		}
		else {
			layout_page_info($langText['NO_BOOKS_RESERVED'], 'error');
		}

		layout_wizard_stop();

	}
	else {
		//add error msg only if view reserved is other priv than view books
	}
}

layout_footer();

?>
